#!/usr/bin/awk
#! -*- coding:utf-8; mode:awk; -*-


BEGIN {
    unique_id = 0;
}

/^<!DOCTYPE [^<>]*>/ {
    print($0);
    print("");
    print("<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->");
    print("<!--   THIS IS A GENERATED FILE; DO NOT EDIT.   -->");
    print("<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->");
    print("");
    next;
}

/<h[0-9]>.*<\/h[0-9]>/ {
    unique_id += 1;
    indent = $0;
    tag = $0;
    title = $0;
    gsub(/<h[0-9].*/, "", indent);
    gsub(/^[^<]*</, "", tag);
    gsub(/>.*$/, "", tag);
    gsub(/\s*<h[0-9]>\s*/, "", title);
    gsub(/\s*<\/h[0-9]>\s*/, "", title);
    printf("%s<%s id=\"anchor-%04x\">%s<a class=\"%s\" href=\"#anchor-%04x\">%s</a></%s>\n",
           indent, tag, unique_id, title, "anchor", unique_id, "&#x00B6;", tag);
    next;
}

/<link [^<>]*>/ {
    indent = $0;
    href = $0;
    type = $0;
    tag = "?";
    gsub(/<link.*/, "", indent);
    gsub(/.*href="/, "", href);
    gsub(/".*/, "", href);
    gsub(/.*type="/, "", type);
    gsub(/".*/, "", type);
    if (type = "text/css") {
        tag = "style";
    } else if (type = "text/javascript") {
        tag = "script";
    } else {
        printf("error: unknown <link type=\"%s\" />\n", type) | "cat >&2";
        exit 1;
    }
    printf("%s<%s type=\"%s\">\n", indent, tag, type);
    printf("%s  /* <![CDATA[ */\n", indent);
    while (getline line < href) {
        printf("%s  %s\n", indent, line);
    }
    printf("%s  /* ]]> */\n", indent);
    printf("%s</%s>\n", indent, tag);
    next;
}

{
    print($0);
}
